# Derivace funkce
- jak moc funkce roste

## Definice
- mějme $f$: $D_f \rightarrow H_f$ a bod $x_0 \in D_f$
- řekněmě, že funkce $f$ má v $x_0$ derivaci, $\exist$-li limita
- $\displaystyle \lim_{ h \to 0 } \frac{f(x_0+h)-f(x_0)}{h} = f'(x_0)$

## Věta 6.1: D => S
- má-li funkce $f$ v bodě $x_0$ **vlastní** derivaci, potom je v tomto bodě spojitá

## Věta 6.2: Pravidla derivování
- a) **LINEARITA**
    - $(\alpha * f(x) + \beta * g(x))' = \alpha * f'(x) + \beta * g'(x)$
- b) **SOUČIN**
    - $(f(x)*g(x))' = f'(x) * g(x) + f(x) * g'(x)$
- c) **PODÍL**
    - $(\frac{f(x)}{g(x)})' = \frac{f'(x)*g(x) - f(x)*g'(x)}{g^2(x)}$
- d) **SLOŽENÁ FUNKCE**
    - $(f(g(x)))' = f'(g(x))*g'(x)$

## Věta 6.4: Derivace inverzní funkce
- (prakticky k ničemu, ale odvodí zbytek tabulky)
- pokud $f'(x_0) \neq 0$, $f$ má spojitou derivaci a je ostře monotónní (tedy inverzní)
- $y_0 = f(x_0)$, pak:
    -  $(f^{-1})(y_0) = \frac {1}{f'(x_0)} = \frac {1}{f'(f^{-1}(y_0))}$

## Aplikace derivací
- aproximace
- optimalizace
- průběh funkce
- výpočty limity